package com.persagy.dmp.admin.service.trans;

import com.persagy.dmp.admin.entity.TransObjectInfo;
import com.persagy.dmp.rwd.model.FuncidDefModel;
import lombok.Data;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author: yaoll
 * @date: 2020-12-30
 * @verison: 1.0
 */
@Data
public class TransObjectContext {

	public static final Integer LOGS_CACHE_SIZE = 1000;

	private String server;

	private String secret;

	private String groupCode;

	private String projectId;

	private String appId = "datautils";

	private String userId = "system";

	private Map<String, String> classCodeMapping = new HashMap<>();

	private Map<String, String> objTypeMapping = new HashMap<>();

	private Map<String, Map<String, FuncidDefModel>> funcidModelCache = new HashMap<>(); // key = classCode

	private List<TransObjectInfo> logs = new ArrayList<>(LOGS_CACHE_SIZE);

}
