package com.persagy.dmp.rwd.edit.entity;


import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.node.ArrayNode;
import com.persagy.dmp.rwd.edit.enumeration.EnumOperationType;
import com.persagy.dmp.rwd.edit.enumeration.EnumVersionState;
import com.persagy.dmp.rwd.enums.ObjType;
import com.vladmihalcea.hibernate.type.json.JsonStringType;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.SQLDelete;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.TypeDef;
import org.hibernate.annotations.Where;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Setter
@Getter
@Entity
@Table(name = "rwd_def_class_change_record")
@TypeDef(name = "json", typeClass = JsonStringType.class)
@Where(clause = "valid = 1")
@SQLDelete(sql = "update rwd_def_class_change_record set valid = 0 where id = ?")
@TypeDef(name = "json", typeClass = JsonStringType.class)
public class ClassDefChangeRecord {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Integer id;
    private String code;
    private String groupCode;
    @Enumerated(value = EnumType.STRING)
    private ObjType objType;
    private String name;
    private String aliasCode;
    private String aliasName;
    private String type;
    private String projectId;
    private String majorCode;
    private String systemCode;
    private String equipmentCode;
    private String parentCode;
    @Enumerated(EnumType.STRING)
    private EnumOperationType operationType;//操作类型
    private String operationUser;//操作人
    private Date operationTime;//操作时间
    @Type(type = "json")
    private ArrayNode operationContentBefore; //操作内容-修改前
    @Type(type = "json")
    private ArrayNode operationContentAfter;//操作内容-修改后
    private String confirmUser;//确认人
    private Date confirmTime;//确认时间
    private String publishUser;//发布人
    private Date publishTime;//发布时间
    private Date finishTime;//完成时间
    private Boolean valid;//true 正常 false 失效
    @Enumerated
    private EnumVersionState state;//状态 0.取消 1.初始化 2.确认 3.发布 4.完成
    private String version;//版本
}
