package com.persagy.dmp.rwd.edit.entity;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.dmp.rwd.model.RwdeditRefTypeInfosModel;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.CreationTimestamp;
import org.hibernate.annotations.Type;
import org.hibernate.annotations.UpdateTimestamp;

import javax.persistence.*;
import java.util.Date;

@Setter
@Getter
@Entity
@Table(name = "rwdedit_ref_type_infos")
@IdClass(RefTypeInfoPK.class)
public class RwdeditRefTypeInfos {

    @Id
    private String refKey;
    @Id
    private String code;
    private String name;
    private String parentCode;
    private String codePath;
    @Type(type = "json")
    private ObjectNode dataSource;
    @Column(updatable = false)
    private Integer createUser;
    @CreationTimestamp
    @Column(updatable = false)
    private Date createTime;
    private Integer seq;
    private Integer updateUser;
    @UpdateTimestamp
    private Date updateTime;

    public static RwdeditRefTypeInfos fromModel(RwdeditRefTypeInfosModel model) {
        RwdeditRefTypeInfos entity = new RwdeditRefTypeInfos();
        entity.setRefKey(model.getRefKey());
        entity.setName(model.getName());
        entity.setCreateTime(model.getCreateTime());
        entity.setUpdateTime(model.getUpdateTime());
        entity.setCreateUser(model.getCreateUser());
        entity.setUpdateUser(model.getUpdateUser());
        entity.setCode(model.getCode());
        entity.setParentCode(model.getParentCode());
        entity.setCodePath(model.getCodePath());
        entity.setDataSource(model.getDataSource());
        return entity;
    }

    public RwdeditRefTypeInfosModel toModel() {
        RwdeditRefTypeInfosModel model = new RwdeditRefTypeInfosModel();
        model.setRefKey(this.getRefKey());
        model.setName(this.getName());
        model.setCodePath(this.getCodePath());
        model.setCreateTime(this.getCreateTime());
        model.setUpdateTime(this.getUpdateTime());
        model.setCreateUser(this.getCreateUser());
        model.setUpdateUser(this.getUpdateUser());
        model.setCode(this.getCode());
        model.setParentCode(this.getParentCode());
        model.setDataSource(this.getDataSource());
        return model;
    }



}
